C ---------------------------------------------------------------------------------        
      SUBROUTINE FIND_FPART(STD,VTD,JC,NSAM,NSAMH,
     +			A3DF,B3DF,C3DF,D3DF,S3DF,V3DF,
     +			A3DS,B3DS,C3DS,D3DS,S3DS,V3DS,
     +                  IREDUN,ASYM,RI,RIC,B3DV,C3DV,
     +                  PSIZE,FMASK,FPART,FSC,SSNR)
C ---------------------------------------------------------------------------------        
C       Find fparticle to scale SSNR for Wiener filter
C       Used in Frealign.
C ---------------------------------------------------------------------------------        
      IMPLICIT NONE
C
      INTEGER L,LL,M,MM,N,NN,JC,NSAM,NSAMH,IS,ID
      INTEGER NSAM3,IREDUN,ISUM,K,NF,I
      REAL PSHFTR,T,MAVE,MSTD,RI,RIC,FMASK,DF,EP,FRAD
      PARAMETER  (T=1.5,DF=0.2,EP=0.02,FRAD=30.0)
      DOUBLE PRECISION STD,VTD,SUM1,SUM2
      REAL S3DF(*),S3DS(*),B3DV(*),C3DV(*),FPART,FPARTMAX
      REAL V3DF(*),V3DS(*),CC,CCMAX,FPART_CC,DF1,FMASK2
      REAL PSIZE,FSC(*),SSNR(*),FRAD2,TT
      COMPLEX A3DF(*),A3DS(*)
      COMPLEX B3DF(*),B3DS(*)
      COMPLEX C3DF(*),C3DS(*)
      COMPLEX D3DF(*),D3DS(*)
      CHARACTER ASYM*3
C ---------------------------------------------------------------------------------        
      IF(STD.EQ.0.0.OR.VTD.EQ.0.0) THEN
        WRITE(*,6100) STD,VTD
6100    FORMAT(' Abnormal termination, probably no accept. particles'/
     .         '   either STD or VTD zero, STD,VTD =',2F15.7/
     .         '   at least two particles needed')
        STOP 'STOP 6100'
      ENDIF

      NSAM3=NSAM*NSAM*NSAM
      FRAD2=2.0*PSIZE/FRAD*NSAM

      DO 60 N=1,NSAM
        NN=N-1
        IF (NN.GE.JC) NN=NN-NSAM
        DO 60 M=1,NSAM
          MM=M-1
          IF (MM.GE.JC) MM=MM-NSAM
          DO 60 L=1,JC
            LL=L-1
            ISUM=(LL+MM+NN)
            PSHFTR=1.0
            IF (MOD(ISUM,2).NE.0) PSHFTR=-1.0
            IF (L.NE.JC) THEN
              ID=L+NSAMH*((M-1)+NSAM*(N-1))
              B3DF(ID)=A3DF(ID)*PSHFTR/(S3DF(ID)+STD*IREDUN)/NSAM3
              C3DF(ID)=(A3DF(ID)+D3DF(ID))*PSHFTR
     .          /((S3DF(ID)+V3DF(ID))+(STD+VTD)*IREDUN)/NSAM3
              C3DF(ID)=C3DF(ID)*EXP(-(LL**2+MM**2+NN**2)/FRAD2)
            ELSE
              IS=M+NSAM*(N-1)
              B3DS(IS)=A3DS(IS)*PSHFTR/(S3DS(IS)+STD*IREDUN)/NSAM3
              C3DS(IS)=(A3DS(IS)+D3DS(IS))*PSHFTR
     .          /((S3DS(IS)+V3DS(IS))+(STD+VTD)*IREDUN)/NSAM3
              C3DS(IS)=C3DS(IS)*EXP(-(LL**2+MM**2+NN**2)/FRAD2)
            ENDIF
60    CONTINUE
C
      CALL RLFT3(B3DF,B3DS,NSAM,NSAM,NSAM,-1)
      CALL RLFT3(C3DF,C3DS,NSAM,NSAM,NSAM,-1)
      IF (ASYM(1:1).EQ.'H') THEN
        CALL MASK3D_C(NSAM,C3DV,RI,RIC,1.0,FMASK2,
     +                MAVE,MSTD)
      ELSE
        CALL MASK3D(NSAM,C3DV,RI,RIC,1.0,FMASK2,
     +              MAVE,MSTD)
      ENDIF
C
      DO 80 K=0,INT(T/0.1)
        TT=MAVE+(T-K*0.1)*MSTD
        ISUM=0
        DO 90 I=1,NSAM3
          IF (C3DV(I).GE.TT) ISUM=ISUM+1
90      CONTINUE
        IF (ISUM.GT.0.2*NSAM3*FMASK2) GOTO 99
80    CONTINUE
C
99    CONTINUE
C
      ISUM=0
      SUM1=0.0
      SUM2=0.0
      DO 70 I=1,NSAM3
        IF (C3DV(I).LT.TT) THEN
          B3DV(I)=0.0
        ELSE
          SUM1=SUM1+B3DV(I)
          SUM2=SUM2+B3DV(I)**2
          ISUM=ISUM+1
        ENDIF
70    CONTINUE
      IF (ISUM.NE.0) THEN
        SUM1=SUM1/ISUM
        SUM2=SUM2/ISUM
      ENDIF
      MAVE=SUM1  
      MSTD=SQRT(ABS(SUM2-SUM1**2))
C
      DF1=-DF
      FPART=0.1
      CCMAX=FPART_CC(JC,NSAM,NSAMH,
     +               B3DF,C3DF,D3DF,S3DF,V3DF,
     +               B3DS,C3DS,D3DS,S3DS,V3DS,
     +               ASYM,RI,RIC,B3DV,C3DV,
     +               FPART,SSNR,MAVE,MSTD,FSC)
10    CONTINUE
      FPART=FPART+DF1
      CC=FPART_CC(JC,NSAM,NSAMH,
     +            B3DF,C3DF,D3DF,S3DF,V3DF,
     +            B3DS,C3DS,D3DS,S3DS,V3DS,
     +            ASYM,RI,RIC,B3DV,C3DV,
     +            FPART,SSNR,MAVE,MSTD,FSC)
      IF (CC.GT.CCMAX) THEN   
        CCMAX=CC
        GOTO 10
      ELSE
        FPART=FPART-DF1
        IF (ABS(DF1).GT.EP) THEN
          DF1=-DF1/3.0
          GOTO 10
        ENDIF
      ENDIF
C
      FPART=ABS(FPART)
      IF (FPART.NE.0.0) THEN
        DO 20 I=1,JC
          SSNR(I)=SSNR(I)/FPART
20      CONTINUE
      ENDIF
C
      RETURN
      END
